<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Dirk Wildt <dirk.wildt@think-visually.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Logical Form' for the 'logical_form' extension.
 *
 * @author  Dirk Wildt <dirk.wildt@think-visually.com>
 * @package TYPO3
 * @subpackage  tx_logicalform
 */
class tx_logicalform_pi1 extends tslib_pibase {
  var $prefixId      = 'tx_logicalform_pi1';    // Same as class name
  var $scriptRelPath = 'pi1/class.tx_logicalform_pi1.php';  // Path to this script relative to the extension dir.
  var $extKey        = 'logical_form';  // The extension key.
  var $pi_checkCHash = true;

  /**
   * The main method of the PlugIn
   *
   * @param string  $content: The PlugIn content
   * @param array   $conf: The PlugIn configuration
   * @return string The content that is displayed on the website
   */
  function main($content,$conf) {
    $this->conf=$conf;
    $this->pi_setPiVarDefaults();
    $this->pi_loadLL();

    $this->bool_submitted             = FALSE;
    $this->bool_captcha_isFirstOrTrue = TRUE;
    $bool_multiple_text               = FALSE;
    $this->init($content,$conf);

    // if the form was submitted
#var_dump (t3lib_div::_POST());
#echo "\n".'====================================='."\n";
#var_dump($this->piVars);
#exit;
#var_dump($GLOBALS['TSFE']);
#exit;

    //var_dump($this->piVars);
    if($this->bool_submitted) {
      $pid = $this->handle_result($content,$conf);
    }
    switch($pid) {
      case(TRUE):
        $arr_url = parse_url($this->pi_getPageLink($pid,$target='',$urlParameters=array()));
        switch($arr_url['scheme']) {
          case(TRUE):
            // Url is absolute
            $str_location = $this->pi_getPageLink($pid,$target='',$urlParameters=array());
            break;
          case(FALSE):
            // Url ist only the path behind the host
            $arr_protocol = explode('/', $_SERVER['SERVER_PROTOCOL']);
            $str_protocol = strtolower($arr_protocol[0]);
            $str_host     = $_SERVER['SERVER_NAME'];
            $str_path     = $this->pi_getPageLink($pid,$target='',$urlParameters=array());
            $str_location = $str_protocol.'://'.$str_host.'/'.$str_path;
            break;
        }
        #echo $str_protocol.'<br />';
        #echo $str_host.'<br />';
        #echo $str_path.'<br />';
        switch($pid == $this->intPidSuccess) {
          case(TRUE):
            $this->mail_client($conf,$str_location);
            $this->mail_report($conf,$str_location);
            #echo "Location: ".$str_location.'<br />';
            header("Location: ".$str_location);
            exit;
            break;
          case(FALSE):
            switch($conf['workflow']) {
              case('failure_page'):
                $this->mail_client($conf,$str_location);
                $this->mail_report($conf,$str_location);
                header("Location: ".$str_location);
                exit;
                break;
              case('form'):
                $content = $this->render_form($content,$conf);
                return $this->pi_wrapInBaseClass($content);
                break;
              default:
                echo '<h1>
                        SETUP ERROR
                      </h1>
                      <p>
                        plugin.'.$this->prefixId.'.workflow has an undefined value: '.$conf['workflow'].'<br />
                        There are allowed only two cases:<br />
                        <br />
                        - failure_page<br />
                        - form<br />
                        <br />
                        Please correct it.
                      </p>
                      ';
                exit;
                break;
            }
            break;
        }
        $this->mail_report($conf,$str_location);
        header("Location: ".$str_location);
        exit();
        break;
      default:
        $content = $this->render_form($content,$conf);
        return $this->pi_wrapInBaseClass($content);
        break;
    }

  }

  /**
  * The method allocates values from the array $conf to class-wide-variables
  *
  * @param string    $content: The PlugIn content
  * @param array     $conf: The PlugIn configuration
  * @return boolean  TRUE in every case
  */
  function init($content, $conf) {
    // check if the form is displayed the first time or if it is submitted
    if($this->piVars) {
      $this->bool_submitted = TRUE;
    }

    $this->strConfTemplPath = $conf['templateFile'];
    $this->strConfCode      = $conf['code'];
    $this->intPidFailure    = $conf['pids.']['failure'];
    $this->intPidSuccess    = $conf['pids.']['success'];
    $this->arrFields        = $conf['fields.'];
    // 0.0.5
    if (t3lib_extMgm::isLoaded('sr_freecap') ) {
      require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
      $this->freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
    }
    return TRUE;
  }









  /**
  * The method renders the form
  *
  * @param string    $content: The PlugIn content
  * @param array     $conf: The PlugIn configuration
  * @return string   The content for displaying the form
  */
  function render_form($content,$conf) {

    // Get the template
    $template = $this->cObj->fileResource($this->strConfTemplPath);

    // fields
    $strFields = '';
    $bool_required_line = FALSE;
    foreach($this->arrFields as $keyFields => $valueFields) {

      // ONLY FOR UNIQUE TYPES LIKE RADIO, TEXTAREA, INPUT
      // $str_name will become a new value in case of CHECKBOX AND SELECT-MULTIPLE
      // f.e.: country., city.
      $str_name = substr($keyFields, 0, strlen($keyFields) - 1);
      $str_id     = $this->prefixId.'['.$str_name.'_id]';
      // Get field and value
      $str_field  = $this->prefixId.'['.$str_name.'_field]'; //
      switch(TRUE) {
        case(!is_array($this->piVars[$str_name.'_field'])):
          // Get submitted values
          $str_value = htmlspecialchars($this->piVars[$str_name.'_field']);
          break;
        default:
          // Case is select an multiple = TRUE
          // Edit values in the select section
          break;
      }
      // Translate the label, if there is a value in the lang-file
      $str_label  = htmlspecialchars($this->pi_getLL('field_'.$str_name));
      if(!$str_label) $str_label = $str_name;

      foreach($this->arrFields[$keyFields] as $keyType => $valueType) {

        $str_error = '';

        // Get default value if the form is displayed the first time
        if(!$this->bool_submitted) {
          $str_value = $this->arrFields[$keyFields][$keyType]['default'];
          // If case is select or checkbox, the values will be edited later too.
        }

        // Get all properties and values
        $arrField = $this->arrFields[$keyFields][$keyType];
        #var_dump($arrField);

        // Get all failure values
        $arr_failure = FALSE;
        if(is_array($this->arrFields[$keyFields][$keyType]['failure.'])) {
          foreach($this->arrFields[$keyFields][$keyType]['failure.'] as $key => $value) {
            $arr_failure[] = $value;
          }
        }


        // If one or more fields are required:
        // 1. set bool_required
        //    a. to generate a last line in the form with a notice (later)
        //    b. th check if the field value is completed (later)
        // 2. Add an asterisk to the label of the field
        switch($this->arrFields[$keyFields][$keyType]['required']) {
          case(TRUE):
            $bool_required_line = TRUE;
            $bool_required = TRUE;
            $str_label_02 = $str_label.'<b>*</b>';
            // In cases of field types checkbox or select-multiple there will be a new check
            if($this->bool_submitted) $str_error = $this->is_field_completed($conf,$str_label,$str_value);
            break;
          default:
            $bool_required = FALSE;
            $str_label_02 = $str_label;
            break;
        }

        // Workaround in dependence of field type (checkbox., radio., select., textarea, input/default)
        switch($keyType) {
          case('checkbox.'):
            $strFields .= $this->field_checkbox($arrField,$str_name,$str_id,$str_label_02,$str_error);
            break;
          case('radio.'):
            $strFields .= $this->field_radio($arrField,$str_name,$str_id,$str_label_02,$str_value,$str_error);
            break;
          case('select.'):
            $strFields .= $this->field_select($arrField,$str_name,$str_id,$str_label_02,$str_error);
            break;
          case('textarea.'):
            if(is_array($arr_failure) && !$str_error) {
              if(in_array($str_value, $arr_failure)) {
                $str_error = htmlspecialchars($this->pi_getLL('error_not_accepted'));
                $str_error = str_replace('|', $str_error, $conf['wrap.']['error']);
              }
            }
            $strFields .= ''.
'        <dt>
          '.$str_error.'<label for="'.$str_id.'">'.$str_label_02.'</label>
        </dt>
        <dd>
          <textarea name="'.$str_field.'" cols="'.$arrField['cols'].'" rows="'.$arrField['rows'].'">'.$str_value.'</textarea>
        </dd>
';
            break;
          case('input.'):
            // input.
            if($arrField['mail'] && $this->bool_submitted) {
              if(!t3lib_div::validEmail($str_value) && !$str_error) {
                $str_error = htmlspecialchars($this->pi_getLL('error_mail'));
                $str_error = str_replace('###MAIL###', '"'.$str_value.'"', $str_error);
                $str_error = str_replace('|', $str_error, $conf['wrap.']['error']);
              }
            }
            if(($arrField['int'] == 1) && $this->bool_submitted) {
              if((string) $str_value != (string) (int) $str_value && !$str_error) {
                $str_error = htmlspecialchars($this->pi_getLL('error_int'));
                $str_error = str_replace('###FIELD###', '"'.$str_label_02.'"', $str_error);
                $str_error = str_replace('|', $str_error, $conf['wrap.']['error']);
              }
            }
            if(is_array($arr_failure) && !$str_error && $this->bool_submitted) {
              if(in_array($str_value, $arr_failure)) {
                $str_error = htmlspecialchars($this->pi_getLL('error_not_accepted'));
                $str_error = str_replace('|', $str_error, $conf['wrap.']['error']);
              }
            }
            $strFields .= ''.
'        <dt>
          '.$str_error.'<label for="'.$str_id.'">'.$str_label_02.'</label>
        </dt>
        <dd>
          <input type="text" name="'.$str_field.'" id="'.$str_id.'" size="'.$arrField['size'].'" maxlength="'.$arrField['maxlength'].'" value="'.$str_value.'">
        </dd>
';
            break;
          default:
            $strFields .= ''.
'<p style="border:4px solid red;">
Sorry, there is a failure in your setup!<br />
The field type isn\'t defined: <strong>'.$keyType.'</strong><br />
Please check the following lines:<br />
plugin.'.$this->prefixId.'.fields.'.$keyFields.'...<br />
';

        }
      }
    }
    if($bool_required_line || $this->bool_multiple_text) {
      if($bool_required_line) {
        $str_line_bottom = htmlspecialchars($this->pi_getLL('required_field'));
      }
      if($this->bool_multiple_text) {
        if($bool_required_line) {
          $str_line_bottom .= '<br />';
        }
        $str_line_bottom .= htmlspecialchars($this->pi_getLL('multiple_text'));
    }
      $str_line_bottom = str_replace('|', $str_line_bottom, $conf['wrap.']['info']);
      $strFields .= ''.
'        '.$str_line_bottom.'
';
    }

    $markerArray['###ACTION###']        = $this->pi_getPageLink($GLOBALS['TSFE']->id);
    // labels
    $markerArray['###LEGEND_LABEL###']  = htmlspecialchars($this->pi_getLL('legend'));
    $markerArray['###SUBMIT_LABEL###']  = htmlspecialchars($this->pi_getLL('submit_button_label'));
    $markerArray['###SUBMIT_BUTTON###'] = $this->prefixId.'[submit_button]';
    // fields
    $markerArray['###FIELDS###']        = $strFields;

    // 0.0.5
    // If extension sr_freeCap is loaded and logical_form wants a captcha
    switch(TRUE) {
      // If captcha should be used but sr_freecap isn't installed
      case(!t3lib_extMgm::isLoaded('sr_freecap') && $conf['captcha']):
        $str_warn = htmlspecialchars($this->pi_getLL('warn_install_captcha'));
        $str_warn = str_replace('|', $str_warn, $conf['captcha.']['wrap.']['error']);
        $template = $this->cObj->substituteSubpart($template,'###CAPTCHA_INSERT###',$str_warn,TRUE);
        break;
      // sr_freecap is installed and captcha is activated
      case(is_object($this->freeCap) && $conf['captcha']):
        $markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
        if(!$this->bool_captcha_isFirstOrTrue) {
          $str_error = htmlspecialchars($this->pi_getLL('error_captcha'));
          $str_error = str_replace('|', $str_error, $conf['captcha.']['wrap.']['error']);
          $markerArray['###SR_FREECAP_CANT_READ###'] .= $str_error;
        }
        break;
      default:
        // Delete the subpart
        $template = $this->cObj->substituteSubpart($template,'###CAPTCHA_INSERT###','',TRUE);
    }

    $subpart = $this->cObj->getSubpart($template, '###'.$this->strConfCode.'###');
    $content = $this->cObj->substituteMarkerArray($subpart, $markerArray);

    return $content;
  }










  /**
  * The method handles the result of the form
  *
  * @param array     $arrField:    Array with the setup properties and setup values of the field
  * @param string    $field_name:  Name of the field e.g. city, country, ...
  * @param string    $field_id:    Id for the html-tag id of the field
  * @param string    $field_label: Label of the field, translated if there is a translation in the lang file
  * @param string    $str_error:   Error message e.g. "Please complete the field ...
  * @return string   The html-code for the input type checkbox
  */
  function field_checkbox($arrField,$field_name,$field_id,$field_label,$str_error) {

    // Get field name e.g. tx_logicalform_pi1[country_field][] and the submitted values
    $str_field = $this->prefixId.'['.$field_name.'_field][]';

    // Get default values or submitted values
    switch($this->bool_submitted) {
      case(TRUE):
        // Get submitted values
        $arr_value = $this->piVars[$field_name.'_field'];
        break;
      case(FALSE):
        // Get default values
        foreach($arrField['default.'] as $key => $value) {
          $arr_value[] = $value;
        }
        break;
    }
    if(is_array($arr_value)) {
      foreach($arr_value as $key => $value) {
        if($value == '') unset($arr_value[$key]);
      }
    }


    switch(count($arr_value) == 0 || !is_array($arr_value)) {
      case(TRUE):
        $arr_value = array();
        break;
      default:
        $str_error = '';
        break;
    }

    // Get all failure values
    $arr_failure = FALSE;
    $bool_error_not_accepted = FALSE;
    if(is_array($arrField['failure.'])) {
      foreach($arrField['failure.'] as $key => $value) {
        $arr_failure[] = $value;
      }
    }

    // Build the html code for the checkbox
    $strCheckbox = '';
    foreach($arrField['value.'] as $key => $value) {

      // Translate the value, if there is a translation in the lang file,
      //   Item in the lang file e.g. <label index="value_usa">United States of America</label>
      $value_LL  = htmlspecialchars($this->pi_getLL('value_'.strtolower($value)));
      if(!$value_LL) $value_LL = $value;

      // Check if items are checked
      switch(TRUE) {
        case(in_array($value, $arr_value)):
          $str_checked = ' checked="checked"';
          break;
        default:
          $str_checked = '';
          break;
      }
      // Add a br-tag, if the setup field plugin.tx_logicalform_pi1.fields.[field_name].checkbox.br is true
      switch($arrField['br']) {
        case(TRUE):
          $strBr = '<br />';
          break;
        case(FALSE):
          $strBr = '';
          break;
      }
      $strCheckbox .= ''.
'            <input type="checkbox" name="'.$str_field.'" value="'.$value.'"'.$str_checked.'> '.$value_LL.$strBr.'
';
    }
    if(is_array($arr_failure) && !$str_error) {
      $arr_intersect = array_intersect($arr_value, $arr_failure);
      if(count($arr_intersect) > 0) {
        $str_error = htmlspecialchars($this->pi_getLL('error_not_accepted_checkbox'));
        $str_error = str_replace('|', $str_error, $this->conf['wrap.']['error']);
      }
    }
    $strReturn = ''.
'        <dt>
          '.$str_error.'<label for="'.$field_id.'">'.$field_label.'</label>
        </dt>
        <dd>
###CHECKBOX###
        </dd>
';
    $strReturn = str_replace('###CHECKBOX###', $strCheckbox, $strReturn);
    return $strReturn;
  }


  /**
  * The method handles the result of the form
  *
  * @param array     $arrField:    Array with the setup properties and setup values of the field
  * @param string    $field_name:  Name of the field e.g. city, country, ...
  * @param string    $field_id:    Id for the html-tag id of the field
  * @param string    $field_label: Label of the field, translated if there is a translation in the lang file
  * @param string    $field_value: Submitted value of the field, translated if there is a translation in the lang file
  * @param string    $str_error:   Error message e.g. "Please complete the field ...
  * @return string   The html-code for the input type radio
  */
  function field_radio($arrField,$field_name,$field_id,$field_label,$field_value,$str_error) {

    $str_field = $this->prefixId.'['.$field_name.'_field]';
    $strRadio = '';

    foreach($arrField['value.'] as $key => $value) {
      // Check fields, if the are checked in default mode or after submitting
      switch(TRUE) {
        case($field_value == $value):
          $str_checked = ' checked="checked"';
          break;
        default:
          $str_checked = '';
          break;
      }
      switch($arrField['br']) {
        case(TRUE):
          $strBr = '<br />';
          break;
        case(FALSE):
          $strBr = '';
          break;
      }
      // Get translated values, if there are some
      $value_LL  = htmlspecialchars($this->pi_getLL('value_'.strtolower($value)));
      if(!$value_LL) $value_LL = $value;
      // Build the input type radio lines
      $strRadio .= ''.
'            <input type="radio" name="'.$str_field.'" value="'.$value.'"'.$str_checked.'> '.$value_LL.$strBr.'
';
    }

    // Get all failure values
    $arr_failure = FALSE;
    $bool_error_not_accepted = FALSE;
    if(is_array($arrField['failure.'])) {
      foreach($arrField['failure.'] as $key => $value) {
        $arr_failure[] = $value;
      }
    }

    if(is_array($arr_failure) && !$str_error) {
      if(in_array($field_value, $arr_failure)) {
        $str_error = htmlspecialchars($this->pi_getLL('error_not_accepted'));
        $str_error = str_replace('|', $str_error, $this->conf['wrap.']['error']);
      }
    }

    // Build the whole html code for the radio field
    $strReturn = ''.
'        <dt>
          '.$str_error.'<label for="'.$field_id.'">'.$field_label.'</label>
        </dt>
        <dd>
###RADIO###
        </dd>
';
    $strReturn = str_replace('###RADIO###', $strRadio, $strReturn);
    return $strReturn;

  }





  /**
  * The method handles the result of the form
  *
  * @param array     $arrField:    Array with the setup properties and setup values of the field
  * @param string    $field_name:  Name of the field e.g. city, country, ...
  * @param string    $field_id:    Id for the html-tag id of the field
  * @param string    $field_label: Label of the field, translated if there is a translation in the lang file
  * @param string    $str_error:   Error message e.g. "Please complete the field ...
  * @return string   The html-code for the input type select
  */
  function field_select($arrField,$field_name,$field_id,$field_label,$str_error) {

    // Get field name e.g. tx_logicalform_pi1[country_field][] and the submitted values
    $str_field = $this->prefixId.'['.$field_name.'_field][]';

    // Get default values or submitted values
    switch($this->bool_submitted) {
      case(TRUE):
        // Get submitted values
        $arr_value = $this->piVars[$field_name.'_field'];
        break;
      case(FALSE):
        // Get default values
        if(is_array($arrField['default.'])) {
          foreach($arrField['default.'] as $key => $value) {
            $arr_value[] = $value;
          }
        }
        break;
    }
    if(is_array($arr_value)) {
      foreach($arr_value as $key => $value) {
        if($value == '') unset($arr_value[$key]);
      }
    }

    // Check if it there is one submitted value at least
    switch(count($arr_value) == 0 || !is_array($arr_value)) {
      case(TRUE):
        $arr_value = array();
        break;
      default:
        $str_error = '';
        break;
    }
    // Check if it is unique or multiple
    switch($arrField['multiple']) {
      case(TRUE):
        $str_multiple = ' multiple="multiple"';
        $str_note     = ' ('.$this->pi_getLL('multiple_label').'**)';
        $this->bool_multiple_text = TRUE;
        break;
      default:
        $str_multiple = '';
        $str_note     = '';
        break;
    }

    // Get all failure values
    $arr_failure = FALSE;
    $bool_error_not_accepted = FALSE;
    if(is_array($arrField['failure.'])) {
      foreach($arrField['failure.'] as $key => $value) {
        $arr_failure[] = $value;
      }
    }

    // Build the html option lines
    $strOption = '';
    foreach($arrField['value.'] as $key => $value) {
      switch(TRUE) {
        case(in_array($value, $arr_value)):
          $str_selected = ' selected="selected"';
          break;
        default:
          $str_selected = '';
          break;
      }
      $strOption .= ''.
'            <option'.$str_selected.'>'.$value.'</option>
';
    }

    if(is_array($arr_failure) && !$str_error) {
      $arr_intersect = array_intersect($arr_value, $arr_failure);
      if(count($arr_intersect) > 0) {
        $str_error = htmlspecialchars($this->pi_getLL('error_not_accepted_select'));
        $str_error = str_replace('|', $str_error, $this->conf['wrap.']['error']);
      }
    }

    $strReturn = ''.
'        <dt>
          '.$str_error.'<label for="'.$field_id.'">'.$field_label.$str_note.'</label>
        </dt>
        <dd>
          <select name="'.$str_field.'" id="'.$field_id.'" size="'.$arrField['size'].$str_multiple.'">
###OPTION###
          </select>
        </dd>
';
    $strReturn = str_replace('###OPTION###', $strOption, $strReturn);
    return $strReturn;
  }








  /**
  * The method handles the result of the form
  *
  * @param string    $content: The PlugIn content
  * @param array     $conf: The PlugIn configuration
  * @return integer  The uid of the success page or failure page
  */
  function handle_result($content,$conf) {

    // Build the result array
    foreach($this->arrFields as $keyFields => $valueFields) {
      // country., city.
      $str_name = substr($keyFields, 0, strlen($keyFields) - 1);

      switch(is_array($this->piVars[$str_name.'_field'])) {
        case(TRUE):
          // Case is select or checkbox
          #echo 'case is checkbox or select: '."<br />\n";
          foreach($this->piVars[$str_name.'_field'] as $key => $value) {
            #echo $key.': '.$value."\n";
            $arr_result[$str_name][] = htmlspecialchars($this->piVars[$str_name.'_field'][$key]);
          }
          break;
        default:
          $arr_result[$str_name] = htmlspecialchars($this->piVars[$str_name.'_field']);
          break;
      }

      // Check if a mail address is correct
      foreach($this->arrFields[$keyFields] as $keyType => $valueType) {
        // f.e.: plugin.tx_logicalform_pi1.fields.mail_field.input.mail = 1
        $arrField = $this->arrFields[$keyFields][$keyType];
        if($arrField['mail']) {
          if(!t3lib_div::validEmail($arr_result[$str_name])) {
            if($conf['mail.']['debug']) {
              echo '<h1>ERROR MAIL</h1><p>'.$str_name.': '.$arr_result[$str_name].'</p>';
            }
            return FALSE;
          }
        }
      }
      // Check if it has to be an integer
      foreach($this->arrFields[$keyFields] as $keyType => $valueType) {
        // f.e.: plugin.tx_logicalform_pi1.fields.account_no.input.int = 1
        $arrField = $this->arrFields[$keyFields][$keyType];
        if($arrField['int']) {
          if((string) $arr_result[$str_name] != (string) (int) $arr_result[$str_name]) {
            #echo '<h1>ERROR INTEGER</h1><p>'.$str_name.': '.$arr_result[$str_name].'</p>';
            return FALSE;
          }
        }
      }
    }
    // 0.0.5
    // If logical_form use captcha, evaluate the captcha field
    if($conf['captcha']) {
      $str_captcha_response = htmlspecialchars($this->piVars['captcha_response']);
      if (is_object($this->freeCap) && !$this->freeCap->checkWord($str_captcha_response)) {
        $this->bool_captcha_isFirstOrTrue = FALSE;
        #echo 'XX';
        #var_dump($arr_result);
        #exit;
        return FALSE;
      }
    }
    #echo "arr_result:<br />";
    #var_dump($arr_result);
    #echo "<br />";
    #echo "<br />";

    // build the failure array
    $strFields = '';
    foreach($this->arrFields as $keyFields => $valueFields) {
      // e.g.: delete the last character - the dot: country., city.
      $str_name = substr($keyFields, 0, strlen($keyFields) - 1);
      foreach($this->arrFields[$keyFields] as $keyType => $valueType) {
        // select., input
        if($this->arrFields[$keyFields][$keyType]['required'] == 1) {
          if(htmlspecialchars($this->piVars[$str_name.'_field'] == '')) return FALSE;
        }
        switch(is_array($this->arrFields[$keyFields][$keyType]['failure.'])) {
          case(TRUE):
            foreach($this->arrFields[$keyFields][$keyType]['failure.'] as $key => $value) {
              $arr_failure[$str_name][$key] = $value;
            }
            break;
          case(FALSE):
            if($this->arrFields[$keyFields][$keyType]['failure']) {
              $arr_failure[$str_name] = $this->arrFields[$keyFields][$keyType]['failure'];
            }
            break;
        }
      }
    }
    #echo "arr_failure:<br />";
    #var_dump($arr_failure);
    #echo "<br />";
    #echo "<br />";

    // evaluate the result
    if(is_array($arr_failure)) {
      foreach($arr_failure as $keyFailure => $valueFailure) {
        if($arr_result[$keyFailure]) {
          switch(is_array($arr_result[$keyFailure])) {
            case(TRUE):
              $arr_intersect = array_intersect($arr_result[$keyFailure], $arr_failure[$keyFailure]);
              if(count($arr_intersect) > 0) return $this->intPidFailure;
              break;
            case(FALSE):
              $arr_intersect = array_intersect($arr_result, $arr_failure[$keyFailure]);
              if(count($arr_intersect) > 0) return $this->intPidFailure;
              break;
          }
        }
      }
    }

    return $this->intPidSuccess;

  }








  /**
  * The method checks, if a field is completed
  *
  * @param array     $conf: The PlugIn configuration
  * @param string    $field_label: Label of the field (translation, if there is one)
  * @param string    $field_value: Value of the field
  * @return string   FALSE if it is completed, if it is empty string with a message
  */
  function is_field_completed($conf,$field_label,$field_value) {
    $strReturn = '';
    if($field_value == '') {
      $strReturn = htmlspecialchars($this->pi_getLL('required_error'));
      $strReturn = str_replace('###FIELD###', '"'.$field_label.'"', $strReturn);
      $strReturn = str_replace('|', $strReturn, $conf['wrap.']['error']);
    }
    return $strReturn;
  }







  /**
  * The method sends mails to the client and others
  *
  * @param array     $conf: The PlugIn configuration
  * @param string    $str_location: The path to which the visitor is guided
  * @return boolean  TRUE if there are one or more receivers, otherwise FALSE
  */
  function mail_report($conf,$str_location) {

        $arr_url = parse_url($this->pi_getPageLink($GLOBALS['TSFE']->id));
        switch($arr_url['scheme']) {
          case(TRUE):
            // Url is absolute
            $str_url = $this->pi_getPageLink($GLOBALS['TSFE']->id);
            break;
          case(FALSE):
            // Url ist only the path behind the host
            $arr_protocol = explode('/', $_SERVER['SERVER_PROTOCOL']);
            $str_protocol = strtolower($arr_protocol[0]);
            $str_host     = $_SERVER['SERVER_NAME'];
            $str_path     = $this->pi_getPageLink($GLOBALS['TSFE']->id);
            $str_url      = $str_protocol.'://'.$str_host.'/'.$str_path;
            break;
        }

    // Check if a mail should be send
    if(!$conf['mail.']['report']) {
      if($conf['mail.']['debug']) {
        echo '<h1>
No mail
</h1>
<p>
The extension '.$this->extKey.' doesn\'t send a mail, because it should not:<br />
plugin.'.$this->prefixId.'.mail.report = '.$conf['mail.']['report'].'<br />
<br />
If the extension should send a mail, please complete the value with a 1<br />
<br />
<br />
</p>
';
      }
      return FALSE;
    }
    // Check if there are receivers for a mail
    $bool_to = FALSE;
    foreach($conf['mail.']['report.']['to.'] as $key => $value) {
      if(!t3lib_div::validEmail($value)) {
        echo '<h1>
There is a wrong mail address
</h1>
<p>
plugin.'.$this->prefixId.'.mail.report.to.'.$key.': '.$value.'<br />
<br />
Please change the value or delete it.<br />
The programm will exit.<br />
<br />
</p>
';
        exit;
      }
      $bool_to = TRUE;
      break;
    }
    if(!$bool_to) {
      if($conf['mail.']['debug']) {
        echo '<h1>
There is no receiver for a mail
</h1>
<p>
The extension '.$this->extKey.' doesn\'t send a mail, because the array is empty:<br />
plugin.'.$this->prefixId.'.mail.report.to<br />
<br />
If the extension should send a mail, please complete the array in your setup.<br />
<br />
<br />
</p>
';
      }
      return FALSE;
    }
    $str_signature = '';
    foreach($conf['mail.']['report.']['signature.'] as $key => $value) {
      $str_signature .= ''.
$value.'
';
    }

    // Get the values with labels in lines
    # 0.0.1: $str_values = $this->label_and_values();
    $str_values = $this->label_and_values($conf);
    #echo nl2br($str_values);
    $str_label  = htmlspecialchars($this->pi_getLL('timestamp'));
    $str_values .= ''.
'
  '.$str_label.': '.date($conf['date']).'
';

    $markerArray['###URL###']         = '  '.$str_url;
    $markerArray['###VALUES###']      = $str_values;
    $markerArray['###URL_FORWARD###'] = '  '.$str_location;
    $markerArray['###SIGNATURE###']   = $str_signature;

    $body    = $this->cObj->substituteMarkerArray($this->pi_getLL('mail_report_text'), $markerArray);
    // 0.0.8
    //$subject = $this->pi_getLL('mail_report_subject');
    $subject = $this->cObj->substituteMarkerArray($this->pi_getLL('mail_report_subject'), $markerArray);

    $header  = "MIME-Version: 1.0\r\n";
    $header .= "Content-type: text/plain; charset=".$this->mail_charset($conf)."\r\n";
    $header .= "FROM: ".$conf['mail.']['report.']['from.']['name']."<".$conf['mail.']['report.']['from.']['mail'].">\r\n";
    $arr_mail = $conf['mail.']['report.']['to.'];
    switch($conf['mail.']['debug']) {
      case(TRUE):
        foreach($arr_mail as $keyMail => $valueMail) {
          echo '<h1>
                  Try to send the following mail
                </h1>
                <p>
                  Header: '.nl2br(htmlentities($header)).'<br />
                  To: '.$conf['mail.']['report.']['to.'][$keyMail].'<br />
                  Subject: '.$subject.'<br />
                  Body: '.nl2br(htmlentities($body)).'
                  <br />
                  <br />
                </p>
                ';
          $boolMail = @mail($conf['mail.']['report.']['to.'][$keyMail], $subject, $body, $header);
          if($boolMail) {
            echo '<h2>
                    PHP Success
                  </h2>
                  <p>
                    PHP reports, that the mail is sended with success.<br />
                    <br />
                    <br />
                  </p>
                  ';
          } else {
            echo '<h2>
                    PHP Failure
                  </h2>
                  <p>
                    PHP reports, that the mail is not sended.<br />
                    <br />
                    <br />
                  </p>
                  ';
          }
        }
        break;
      default:
        foreach($arr_mail as $keyMail => $valueMail) {
          mail($conf['mail.']['report.']['to.'][$keyMail], $subject, $body, $header);
        }
        break;
    }

    return TRUE;
  }






  /**
  * The method sends mails to the client and others
  *
  * @param array     $conf: The PlugIn configuration
  * @param string    $str_location: The path to which the visitor is guided
  * @return boolean  TRUE if there are one or more receivers, otherwise FALSE
  */
  function mail_client($conf,$str_location) {

    // Check if a mail should be send
    if(!$conf['mail.']['to_client']) {
      if($conf['mail.']['debug']) {
        echo '<h1>
                No mail to client
              </h1>
              <p>
                plugin.'.$prefixId.'.mail.to_client: FALSE
              </p>
              ';
      }
      return FALSE;
    }

    // If there is field name for the client mail address it is an error
    if(!$conf['mail.']['to_client.']['field']) {
      echo '<h1>SETUP ERROR</h1>
            <p>
              You have to configure the setup value<br />
              plugin.'.$prefixId.'.mail.to_client.field<br />
              <br />
              The value has to be the name of the field in the form, which is the mail aof the client.
            </p>';
      exit;
    }
    // Get the client mail address
    $field_name = $conf['mail.']['to_client.']['field'];
    $mail_to = $this->piVars[$field_name.'_field'];

    // Build the header
    $mail_from_name = $conf['mail.']['to_client.']['from.']['name'];
    $mail_from_mail = $conf['mail.']['to_client.']['from.']['mail'];
    $header  = "MIME-Version: 1.0\r\n";
    $header .= "Content-type: text/plain; charset=".$this->mail_charset($conf)."\r\n";
    $header .= "From: ".$mail_from_name." <".$mail_from_mail.">\r\n";
    if($conf['mail.']['to_client.']['bcc']) {
      $mail_bcc = $conf['mail.']['to_client.']['bcc'];
      $header .= "Bcc: ".$mail_bcc."\r\n";
    }
    if($conf['mail.']['to_client.']['cc']) {
      $mail_cc = $conf['mail.']['to_client.']['cc'];
      $header .= "Cc: ".$mail_cc."\r\n";
    }

    // Build the signature
    $str_signature = '';
    foreach($conf['mail.']['to_client.']['signature.'] as $key => $value) {
      $str_signature .= ''.
$value.'
';
    }
    #echo nl2br(htmlspecialchars($str_signature));

    // Get the values with labels in lines
    # 0.0.1: $str_values = $this->label_and_values();
    $str_values = $this->label_and_values($conf);
    #echo nl2br($str_values);

    // Build the url
        $arr_url = parse_url($this->pi_getPageLink($GLOBALS['TSFE']->id));
        switch($arr_url['scheme']) {
          case(TRUE):
            // Url is absolute
            $str_url = $this->pi_getPageLink($GLOBALS['TSFE']->id);
            break;
          case(FALSE):
            // Url ist only the path behind the host
            $arr_protocol = explode('/', $_SERVER['SERVER_PROTOCOL']);
            $str_protocol = strtolower($arr_protocol[0]);
            $str_host     = $_SERVER['SERVER_NAME'];
            $str_path     = $this->pi_getPageLink($GLOBALS['TSFE']->id);
            $str_url      = $str_protocol.'://'.$str_host.'/'.$str_path;
            break;
        }

    // Build the array marker
    $markerArray['###URL###']        = '  '.$str_url;
    $markerArray['###VALUES###']     = $str_values;
    $markerArray['###SIGNATURE###']  = $str_signature;
    foreach($conf['fields.'] as $key => $value) {
      // Delete the last the character, the dot
      $marker_name = substr($key, 0, strlen($key) - 1);
      # 0.0.1: $markerArray['###VALUE_'.strtoupper($marker_name).'###'] = $this->piVars[strtolower($marker_name).'_field'];
      # 0.0.2 START
      $tmp_arrKeyType = array_keys($conf['fields.'][$key]);
      $strType = $tmp_arrKeyType[0];
      switch(TRUE) {
        case($conf['fields.'][$key][$strType]['send_keyed'] && $strType == 'input.'):
          #echo '$conf[fields.]['.$key.']['.$strType.'][send_keyed]'."<br />\n";
          $tmp_value = $this->piVars[strtolower($marker_name).'_field'];
          $tmp_strLen = strlen($this->piVars[strtolower($marker_name).'_field']);
          $strSign = $conf['fields.'][$key][$strType]['send_keyed.']['symbol'];
          if($strSign == '') $strSign = '#';
          $intStart = $conf['fields.'][$key][$strType]['send_keyed.']['start'];
          if($strStart == '') $strStart = 0;
          $tmp_value_keyed = substr($tmp_value, 0, $intStart);
          $tmp_lenKeyed = $tmp_strLen - $intStart;
          if($tmp_lenKeyed < 2) $tmp_lenKeyed = 4;
          $tmp_value_keyed .= str_repeat($strSign, $tmp_lenKeyed);
          $markerArray['###VALUE_'.strtoupper($marker_name).'###'] = $tmp_value_keyed;
          #echo '###VALUE_'.strtoupper($marker_name).'###: '.$tmp_value_keyed."<br />\n";
          break;
        default:
          $markerArray['###VALUE_'.strtoupper($marker_name).'###'] = $this->piVars[strtolower($marker_name).'_field'];
          break;
      }
      # 0.0.2 END
    }

    // Build body and subject
    $body_ll_field = $conf['mail.']['to_client.']['body'];
    // 0.0.8
    #$body    = $this->pi_getLL($body_ll_field.'_text');
    #$body    = $this->cObj->substituteMarkerArray($body, $markerArray);
    #$subject = $this->pi_getLL($body_ll_field.'_subject');
    $body    = $this->cObj->substituteMarkerArray($this->pi_getLL($body_ll_field.'_text'), $markerArray);
    $subject = $this->cObj->substituteMarkerArray($this->pi_getLL($body_ll_field.'_subject'), $markerArray);
    #echo nl2br(htmlspecialchars($body));
    #exit;

    // Send the mail
    if($conf['mail.']['debug']) {
      echo '<h1>
              Try to send the following mail
            </h1>
            <p>
              Header: '.nl2br(htmlentities($header)).'<br />
              To: '.$mail_to.'<br />
              Subject: '.$subject.'<br />
              Body: '.nl2br(htmlentities($body)).'
            </p>
            ';
    }
    $boolMail = mail($mail_to, $subject, $body, $header);
    if($conf['mail.']['debug']) {
      if($boolMail) {
        echo '<h2>
                PHP Success
              </h2>
              <p>
                PHP reports, that the mail is sended with success.
              </p>
              ';
      } else {
        echo '<h2>
                PHP Failure
              </h2>
              <p>
                PHP reports, that the mail is not sended.
              </p>
              ';
      }
    }

    return TRUE;
  }





  /**
  * The method generates lines out of the submitted field_labels und field_values
  *
  * @return string  Lines with the structure: label: value
  */
  # 0.0.1: function label_and_values() {
  function label_and_values($conf) {

    $str_label_and_values = '';
    foreach($this->arrFields as $keyFields => $valueFields) {
      // country., city.
      $field_name  = substr($keyFields, 0, strlen($keyFields) - 1);
      $field_label = htmlspecialchars($this->pi_getLL('field_'.$field_name));
      if(!$field_label) $field_label = $field_name;
      switch(is_array($this->piVars[$field_name.'_field'])) {
        case(TRUE):
          // Case is select or checkbox
          $field_value = '';
          foreach($this->piVars[$field_name.'_field'] as $key => $value) {
            $value = htmlspecialchars($value);
            $value_LL  = htmlspecialchars($this->pi_getLL('value_'.strtolower($value)));
            if(!$value_LL) $value_LL = $value;
            $field_value .= $value_LL.', ';
          }
          $field_value = substr($field_value, 0, strlen($field_value) - 2);
          break;
        case(FALSE):
          $value = htmlspecialchars($this->piVars[$field_name.'_field']);
          $value_LL  = htmlspecialchars($this->pi_getLL('value_'.strtolower($value)));
          if(!$value_LL) $value_LL = $value;
          # 0.0.1: $field_value = $value_LL;
          # 0.0.2 START
          #echo $field_name."<br />\n";
          $tmp_arrKeyType = array_keys($conf['fields.'][$field_name.'.']);
          $strType = $tmp_arrKeyType[0];
          if($conf['fields.'][$field_name.'.'][$strType]['send_keyed'] && $strType == 'input.') {
            switch(TRUE) {
              case($conf['fields.'][$field_name.'.'][$strType]['int'] == 1):
                #echo $value_LL.' * '.$conf['key_prod']."<br />\n";
                $value_LL = $value_LL * $conf['key_prod'];
                $value_LL .= '/'.$conf['key_prod'];;
                break;
              default:
                $value_LL = strrev($value_LL);
                $value_LL .= '/rev';
                break;
            }
          }
          $field_value = $value_LL;
          # 0.0.2 END
          break;
      }
      $str_label_and_values .= ''.
'  '.$field_label.': '.$field_value.'
';

    }
    return $str_label_and_values;
  }





  /**
  * The method sends mails to the client and others
  *
  * @param array     $conf: The PlugIn configuration
  * @return string   Charset for the mail header
  */
  function mail_charset($conf) {

    $boolCharsetEmpty = FALSE;
    if(!$conf['mail.']['charset']) {
      $boolCharsetEmpty = TRUE;
    } else {
      if($conf['mail.']['charset'] == "") {
        $boolCharsetEmpty = TRUE;
      }
    }
    switch(TRUE) {
      case($boolCharsetEmpty):
        $strCharset = 'iso-8859-15';
        break;
      default:
        $strCharset = $conf['mail.']['charset'];
        break;
    }
    return $strCharset;
  }

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/logical_form/pi1/class.tx_logicalform_pi1.php']) {
  include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/logical_form/pi1/class.tx_logicalform_pi1.php']);
}

?>